//
//  Templates.swift
//  SwiftFunc
//
//  Created by Saleh on 11/14/19.
//

import Foundation

internal struct Templates {
    
    struct ProjectFiles {
        
        static let functionJson = """
            {{ bindings }}
        """
        
        static let hostJsonDebug = """
            {
                "version": "2.0",
                "extensionBundle": {
                    "id": "Microsoft.Azure.Functions.ExtensionBundle",
                    "version": "[1.*, 2.0.0)"
                }
            }
        """
        
        static let hostJson = """
            {
                "version": "2.0"
            }
        """
        
        static let workerConfigJson = """
            {
                "description": {
                    "arguments": [
                        "run"
                    ],
                    "defaultExecutablePath": "{{ execPath }}",
                    "extensions": [
                        ".swift"
                    ],
                    "language": "swift"
                }
            }
        """
        
        static let localSettingsJson = """
        {
            "IsEncrypted": false,
            "Values": {
                "FUNCTIONS_WORKER_RUNTIME": "swift",
                "languageWorkers:workersDirectory": "workers",
                {{ envVars }}
            }
        }
        """
        
        static let mainSwift = """
        //
        //  main.swift
        //  {{ name }}
        //
        //  Auto Generated by SwiftFunctionsSDK
        //
        //  Do Not modify/change code outside the marked area.
        //  Only register/remove Functions. Do Not add other code
        //

        import SwiftFunc

        let registry = FunctionRegistry()

        // ****** register/remove your functions ******

        //registry.register(name: "name", function: MyFunction.self)

        // ******

        AzureFunctionsWorker.shared.main(registry: registry)

        """
        
        static let mainSwiftWithFunctions =
        """
        //
        //  main.swift
        //  {{ name }}
        //
        //  Auto Generated by SwiftFunctionsSDK
        //
        //  Do Not modify/change code outside the marked area.
        //  Only register/remove Functions. Do Not add other code
        //

        import SwiftFunc

        let registry = FunctionRegistry()

        {{ functions }}

        AzureFunctionsWorker.shared.main(registry: registry)
        """
        
        static let packageSwift = """
            // swift-tools-version:5.0
            // The swift-tools-version declares the minimum version of Swift required to build this package.

            import PackageDescription

            let package = Package(
                name: " {{ name }} ",
                products: [
                    .executable(name: "functions", targets: ["{{ name }}"]),
                ],
                dependencies: [
                    // Dependencies declare other packages that this package depends on.
                    // .package(url: /* package url */, from: "1.0.0"),
                     .package(url: "../SwiftFunc", from: "0.0.2"),
                ],
                targets: [
                    // Targets are the basic building blocks of a package. A target can define a module or a test suite.
                    // Targets can depend on other targets in this package, and on products in packages which this package depends on.
                    .target(
                        name: "{{ name }}",
                        dependencies: [])
                ]
            )
        """
        
    }
}
